/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci_cm@deepin.com>
 *
 * Maintainer: caimengci <caimengci_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "antiavdatamodel.h"

AntiavDataModel *AntiavDataModel::m_pInstance = nullptr;
AntiavDataModel::AntiavDataModel(QObject *parent) :
    QObject(parent)
{

}

void AntiavDataModel::setCModule(CModule_Antiav *mm)
{
    m_cModule_Antiav = mm;
}

void AntiavDataModel::setInstance()
{
    m_pInstance = new AntiavDataModel(this);
}

AntiavDataModel *AntiavDataModel::getInstance()
{
    return m_pInstance;
}

/****************扫描******************/
void AntiavDataModel::dissection(bool bAllDissection, std::vector<std::string> paths)
{
    if (m_pInstance->m_cModule_Antiav->dissection(bAllDissection, paths, m_pInstance->dissectionCallBack))
    {
        Q_EMIT m_pInstance->onDissectionFinished();
    }
}

void AntiavDataModel::dissectionCallBack(std::string path, double progress, FileInfo *detail)
{

   // printf("path = %s, progress = %f\n", path.c_str(), progress);
    // 获取扫描信息
    QString sPath = QString::fromStdString(path);
    double dProgress = progress;
    Type eType = detail->type;
    QString sDetailInfo = QString::fromStdString(detail->detail);

    Q_EMIT m_pInstance->onDissectionCall(sPath, dProgress, eType, sDetailInfo);
}
















