/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci_cm@deepin.com>
 *
 * Maintainer: caimengci <caimengci_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "Antiav.h"
#include "Antiav_common.h"

#include <QObject>

class AntiavDataModel : public QObject
{
    Q_OBJECT
public:
    explicit AntiavDataModel(QObject *parent = nullptr);

    void setCModule(CModule_Antiav *mm);
    // 获取单例
    void setInstance();
    static AntiavDataModel *getInstance();

    // 扫描
    void dissection(bool bAllDissection, std::vector<std::string> paths);
    static void dissectionCallBack(std::string path, double progress, FileInfo *detail);

Q_SIGNALS:
    // 发送扫描信号
    void onDissectionCall(QString sID, double dProgress, Type eType, QString sDetailInfo);
    void onDissectionFinished();

private:
    static AntiavDataModel *m_pInstance;                 // 单例
    CModule_Antiav* m_cModule_Antiav;
};
