#include "antiavdatathread.h"

#include <QDebug>

AntiavDataThread::AntiavDataThread(CModule_Antiav *m)
    : mm(m)
{
}

void AntiavDataThread::setDissectionPath(bool bAllDissection, std::vector<std::string> paths)
{
    m_bAllDissection = bAllDissection;
    m_paths = paths;
}

void AntiavDataThread::run()
{
    m_antiavDatamodel = new AntiavDataModel();
    m_antiavDatamodel->setCModule(mm);
    m_antiavDatamodel->setInstance();
    AntiavDataModel *hand = AntiavDataModel::getInstance();
    connect(hand, SIGNAL(onDissectionCall(QString, double, Type, QString)), this, SLOT(doDissectionResult(QString, double, Type, QString)), Qt::DirectConnection);
    connect(hand, SIGNAL(onDissectionFinished()), this, SLOT(doDissectionFinished()), Qt::DirectConnection);

    doDissection(m_bAllDissection, m_paths);
}

/*****************扫描（全盘/自定义）*********************/
void AntiavDataThread::doDissection(bool bAllDissection, std::vector<std::string> paths)
{
    m_antiavDatamodel->dissection(bAllDissection, paths);
}

void AntiavDataThread::doDissectionResult(QString sPath, double dProgress, Type eType, QString sDetailInfo)
{
    //qDebug() << QString("path = %1, progress = %2, type = %3, info = %4 ").arg(sPath).arg(dProgress).arg(eType).arg(sDetailInfo);
    Q_EMIT sendDissectionResult(sPath, dProgress, eType, sDetailInfo);
}

void AntiavDataThread::doDissectionFinished()
{
    Q_EMIT sendDissectionFinished();
}
