#ifndef ANTIAVDATATHREAD_H
#define ANTIAVDATATHREAD_H

#include "Antiav.h"
#include "Antiav_common.h"
#include "antiavdatamodel.h"

#include <QThread>

class AntiavDataThread : public QThread
{
    Q_OBJECT
public:
    explicit AntiavDataThread(CModule_Antiav *m);

    void setDissectionPath(bool bAllDissection, std::vector<std::string> paths);
    void run();

public Q_SLOTS:
    // 扫描 （全盘true/自定义false）
    void doDissection(bool bAllDissection, std::vector<std::string> paths);
    void doDissectionResult(QString sID, double dProgress, Type eType, QString sDetailInfo);
    void doDissectionFinished();


Q_SIGNALS:
    // 扫描回调函数对外信号
    void sendDissectionResult(QString sPath, double dProgress, Type eType, QString sDetailInfo);
    void sendDissectionFinished();

private:
    AntiavDataModel *m_antiavDatamodel;

    CModule_Antiav *mm;

    bool m_bAllDissection = true;
    std::vector<std::string> m_paths;

};

#endif // ANTIAVDATATHREAD_H
