QT += core gui dbus

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = deepin-defender-daemonservice
TEMPLATE = app
CONFIG += c++11 link_pkgconfig
PKGCONFIG += dtkwidget dframeworkdbus gsettings-qt

SOURCES += \
        main.cpp \
        servicedbus.cpp \
        common/common.cpp \
    dbususermanager.cpp

HEADERS += \
        servicedbus.h \
        common/common.h \
    dbususermanager.h

dbus.files = com.deepin.defender.daemonservice.xml

DBUS_ADAPTORS += dbus
DBUS_INTERFACES += dbus

CONFIG(release, debug|release) {
    TRANSLATIONS = $$files($$PWD/translations/*.ts)
    #遍历目录中的ts文件，调用lrelease将其生成为qm文件
    for(tsfile, TRANSLATIONS) {
        qmfile = $$replace(tsfile, .ts$, .qm)
        system(lrelease $$tsfile -qm $$qmfile) | error("Failed to lrelease")
    }
    #将qm文件添加到安装包
    dtk_translations.path = /usr/share/$$TARGET/translations
    dtk_translations.files = $$PWD/translations/*.qm
    INSTALLS += dtk_translations
}

target.path = /usr/bin/

install_autostart.files = ./deepin-defender-daemonservice.desktop
install_autostart.path = /etc/xdg/autostart/

install_service.files = ./com.deepin.defender.daemonservice.service
install_service.path = /usr/share/dbus-1/services

install_gsettings.files = ./schemas/*.gschema.xml
install_gsettings.path = /usr/share/glib-2.0/schemas/

INSTALLS += target install_autostart install_service install_gsettings

DISTFILES += \
    schemas/com.deepin.defender.deamonservice.gschema.xml \
    schemas/com.deepin.defender.deamonservice.gschema.xml
