QT += core gui dbus sql dtkwidget

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = deepin-defender-datainterface
TEMPLATE = app
CONFIG += c++11 link_pkgconfig
PKGCONFIG += dframeworkdbus gsettings-qt xcb xcb-util dtkwm gio-unix-2.0

SOURCES += \
    main.cpp \
    operatedbusdata.cpp \
    csingleteon.cpp \
    window/modules/startup/startupmonitordialog.cpp \
    window/modules/startup/startupmonitor.cpp \
    window/modules/startup/dbustartmanager.cpp \
    window/modules/trafficdetails/usedata.cpp \
    window/modules/trafficdetails/trafficdetailsworker.cpp \
    window/modules/common/utils.cpp \
    window/modules/common/process_tree.cpp \
    window/modules/common/find_window_title.cpp \
    window/modules/common/common.cpp \
    window/modules/analysisapp/getpiddetailname.cpp \
    window/modules/analysisapp/defenderprocessinfolist.cpp \
    window/modules/analysisapp/defenderprocessinfo.cpp \
    window/modules/common/getprocinfointer.cpp \
    window/modules/common/defenderprocinfo.cpp \
    window/modules/common/defenderprocinfolist.cpp \
    window/modules/netcontrol/netcontrolmodel.cpp \
    window/modules/remcontrol/remcontrolmodel.cpp \
    window/modules/networkmonitor/netcontrolmonitor.cpp \
    window/modules/antivirus/threatdata.cpp \
    window/modules/antivirus/usbscanwork.cpp \
    window/modules/netcontrol/netdisabledialog.cpp \
    window/modules/netcontrol/netaskdialog.cpp \
    window/modules/remcontrol/remdisabledialog.cpp \
    window/modules/remcontrol/remaskdialog.cpp

HEADERS += \
    operatedbusdata.h \
    common.h \
    csingleteon.h \
    window/namespace.h \
    window/modules/startup/startupmonitordialog.h \
    window/modules/startup/startupmonitor.h \
    window/modules/startup/dbustartmanager.h \
    window/modules/trafficdetails/usedata.h \
    window/modules/trafficdetails/trafficdetailsworker.h \
    window/modules/common/utils.h \
    window/modules/common/process_tree.h \
    window/modules/common/hashqstring.h \
    window/modules/common/find_window_title.h \
    window/modules/common/common.h \
    window/modules/analysisapp/getpiddetailname.h \
    window/modules/analysisapp/defenderprocessinfolist.h \
    window/modules/analysisapp/defenderprocessinfo.h \
    window/modules/common/getprocinfointer.h \
    window/modules/common/defenderprocinfo.h \
    window/modules/common/defenderprocinfolist.h \
    window/modules/netcontrol/netcontrolmodel.h \
    window/modules/remcontrol/remcontrolmodel.h \
    window/modules/networkmonitor/netcontrolmonitor.h \
    window/modules/antivirus/threatdata.h \
    window/modules/antivirus/usbscanwork.h \
    window/modules/netcontrol/netdisabledialog.h \
    window/modules/netcontrol/netaskdialog.h \
    window/modules/remcontrol/remdisabledialog.h \
    window/modules/remcontrol/remaskdialog.h

LIBS += -L"libprocps" -lprocps
LIBS += -lX11 -lXext -lXtst -ldtkwm

dbus.files = com.deepin.defender.datainterface.xml
dbus.header_flags += -i /usr/include/libdframeworkdbus-2.0/types/defenderdisplay.h
dbus.header_flags += -i /usr/include/libdframeworkdbus-2.0/types/defenderappflow.h

dbus.source_flags += -i /usr/include/libdframeworkdbus-2.0/types/defenderprocessinfo.h
dbus.header_flags += -i /usr/include/libdframeworkdbus-2.0/types/defenderprocessinfo.h

dbus.source_flags += -i /usr/include/libdframeworkdbus-2.0/types/defenderprocesslist.h
dbus.header_flags += -i /usr/include/libdframeworkdbus-2.0/types/defenderprocesslist.h

dbus.header_flags += -i $$PWD/window/modules/common/defenderprocinfo.h
dbus.header_flags += -i $$PWD/window/modules/common/defenderprocinfolist.h

DBUS_ADAPTORS += dbus
DBUS_INTERFACES += dbus

CONFIG(release, debug|release) {
    TRANSLATIONS = $$files($$PWD/translations/*.ts)
    #遍历目录中的ts文件，调用lrelease将其生成为qm文件
    for(tsfile, TRANSLATIONS) {
        qmfile = $$replace(tsfile, .ts$, .qm)
        system(lrelease $$tsfile -qm $$qmfile) | error("Failed to lrelease")
    }
    #将qm文件添加到安装包
    dtk_translations.path = /usr/share/$$TARGET/translations
    dtk_translations.files = $$PWD/translations/*.qm
    INSTALLS += dtk_translations
}

target.path = /usr/bin/

install_gsettings.files = ./schemas/com.deepin.dde.deepin-defender-datainterface.gschema.xml
install_gsettings.path = /usr/share/glib-2.0/schemas/
install_service.files = com.deepin.defender.datainterface.service
install_service.path = /usr/share/dbus-1/services

INSTALLS += target install_gsettings install_service

DISTFILES += \
    com.deepin.defender.datainterface.service \
    window/modules/trafficdetails/deepin-defender-trafficdetails.desktop

