#include "threatdata.h"

#include <QDir>
#include <QSqlTableModel>

ThreatData::ThreatData(QObject *parent) : QObject(parent)
{
    //初始化数据库
    initDataBase();
}

void ThreatData::initDataBase()
{
    m_sqlDb = QSqlDatabase::addDatabase("QSQLITE", "nativirusDB");
    QDir dir;
    QString dir_str = QString("%1/.deepin-defender/").arg(QDir::homePath());
    //目录不存在，就创建
    if (!dir.exists(dir_str)) {
        dir.mkpath(dir_str);
    }
    m_dbPath = dir_str + QString("threatDetail.db");
    m_sqlDb.setDatabaseName(m_dbPath);
    if (m_sqlDb.open()) {
        qDebug() << "db open success! ";
    } else {
        qDebug() << "db open failed! ";
    }
    //读取数据
    m_sqlQuery = QSqlQuery(m_sqlDb);

    // 创建异常详情表
    if (!m_sqlDb.tables().contains("threatDetail")) {
        bool suc = m_sqlQuery.exec("CREATE TABLE threatDetail (filePath text);");
        if (!suc) {
            qDebug() << m_sqlQuery.lastError();
        }
    }
     qDebug() << "threatDetail table create success!";
}


// 添加异常数据
bool ThreatData::appendThreatDataByPath(QString sfilePath)
{
    // 是否插入成功
    bool ret;
    QString sql = QString("INSERT INTO threatDetail VALUES('%1');").arg(sfilePath);
    if (!m_sqlQuery.exec(sql)) {
        qDebug() << m_sqlQuery.lastError();
        ret = false;
    } else {
        ret = true;
    }
    return ret;
}

// 删除异常数据
bool ThreatData::deleteThreatDataByPath(QString sfilePath)
{
    // 是否删除成功
    bool ret;
    QString sql = QString("delete from threatDetail where filePath = '%1';").arg(sfilePath);
    if (!m_sqlQuery.exec(sql)) {
        qDebug() << m_sqlQuery.lastError();
        ret = false;
    } else {
        ret = true;
    }
    return ret;
}

// 查询异常数据
bool ThreatData::selectThreatDataByPath(QString sfilePath)
{
    // 是否查询成功
    bool flag;
    QString sql = QString("select filePath from threatDetail where filePath = '%1';").arg(sfilePath);
    m_sqlQuery.exec(sql);
    if (m_sqlQuery.next()) {
        flag = true;
    } else {
        flag = false;
    }
    return flag;
}

// 查询总的数据
QStringList ThreatData::selectThreatCount()
{
    QStringList list;
    QString sql = QString("select * from threatDetail;");
    m_sqlQuery.exec(sql);
    while (m_sqlQuery.next()) {
        list.append(m_sqlQuery.value("filePath").toString());
    }
    return  list;
}

int ThreatData::notifySelectThreatCount()
{
    m_sqlQuery.exec("select * from threatDetail;");
    QSqlQueryModel *queryModel = new QSqlQueryModel();
    queryModel->setQuery(m_sqlQuery);
    int nRecordCount = queryModel->rowCount();
    qDebug()<<"查询出的记录条数==="<<nRecordCount;
    return nRecordCount;

    //Q_EMIT threadsCount(nRecordCount);
}
