#ifndef NETASKDIALOG_H
#define NETASKDIALOG_H

#include "com_deepin_defender_datainterface.h"

#include <DWidget>
#include <DDialog>
#include <DLabel>
#include <QTimer>

DWIDGET_USE_NAMESPACE

static const int NET_TIMEOUT_COUNT = 15;
using DataInterFaceServer = com::deepin::defender::datainterface;

class NetAskDialog : public DTK_WIDGET_NAMESPACE::DDialog
{
    Q_OBJECT
public:
    explicit NetAskDialog(const QString &sDkgName, const QString &sAppName, const QString &sId, DDialog *parent = nullptr);
    ~NetAskDialog() override;

private:
    // 初始化界面
    void initUi();

Q_SIGNALS:
    // 弹框关闭信号
    void onDialogClose();

private:
    DataInterFaceServer  *m_DataInterFaceServer = nullptr; // 联网管控接口

    const QString         m_sAppName;
    const QString         m_sPkgName;
    const QString         m_sId;

    QTimer               *m_timer            = nullptr;
    int                   m_elapsedSeconds   = NET_TIMEOUT_COUNT;
};

#endif // NETASKDIALOG_H
