#ifndef NETDISABLEDIALOG_H
#define NETDISABLEDIALOG_H

#include "com_deepin_defender_hmiscreen.h"

#include <DWidget>
#include <DDialog>
#include <DLabel>
#include <QTimer>

DWIDGET_USE_NAMESPACE
static const int TIMEOUT_COUNT = 15;

using HmiScreen = com::deepin::defender::hmiscreen;
class NetDisableDialog : public DTK_WIDGET_NAMESPACE::DDialog
{
    Q_OBJECT
public:
    explicit NetDisableDialog(const QString &sDkgName, const QString &sAppName, DDialog *parent = nullptr);
    ~NetDisableDialog() override;

private:
    // 初始化界面
    void initUi();

Q_SIGNALS:
    // 发送联网管控显示弹框信号
    void requestShowNetControlWidget();

    // 弹框关闭信号
    void onDialogClose();

private:
    QString      m_sAppName;
    QString      m_sPkgName;

    QTimer      *m_timer            = nullptr;
    int          m_elapsedSeconds   = TIMEOUT_COUNT;

    HmiScreen    *m_hmiScreen        = nullptr;
};

#endif // NETDISABLEDIALOG_H
