/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci_cm@deepin.com>
 *
 * Maintainer: caimengci <caimengci_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "com_deepin_dde_daemon_launcherd.h"
#include "dbustartmanager.h"

#include <DDialog>

#include <QObject>
#include <QCloseEvent>
#include <QDBusPendingReply>
#include <QTimer>

using Launcherd = com::deepin::dde::daemon::Launcher;
DWIDGET_USE_NAMESPACE

class StartupMonitorDialog : public DDialog
{
    Q_OBJECT
public:
    explicit StartupMonitorDialog(DDialog *parent = nullptr);
    ~StartupMonitorDialog() override;

    void setAppsName(QString sAppsName);
    void setAppsPath(QString sAppsPath);
private:
    void initUI();
    void deleteFile();

private Q_SLOTS:
    void closeDialog();
    void showButtonTime();

protected:
    void closeEvent(QCloseEvent *event) override;

Q_SIGNALS:
    void monitorChange();
    void onDialogClose();

private:
    QString m_sAppsName;
    QString m_sAppsPath;
    DBusStartManager   *m_startManagerInterface = nullptr;      // 自启动接口
    int m_nTimeCout = 0;

    QTimer *m_showTimer = nullptr;
    QTimer *m_closeTimer = nullptr;
    Launcherd          *m_launcherInter     = nullptr;          // 取应用数据接口
};
