QT += core gui dbus charts sql dtkwidget svg

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = deepin-defender
TEMPLATE = app
CONFIG += c++11 link_pkgconfig
PKGCONFIG += gsettings-qt dframeworkdbus polkit-qt5-1 gio-unix-2.0 dtkcore

load(dtk_qmake)

INCLUDEPATH += src
include($$PWD/src/window/modules/modules.pri)

isEmpty(VERSION) {
    VERSION = 2.0.4
}
DEFINES += QMAKE_TARGET=\\\"$$TARGET\\\" QMAKE_VERSION=\\\"$$VERSION\\\"

SOURCES += \
        src/main.cpp \
        src/window/interface/moduleinterface.cpp \
        src/window/mainwindow.cpp \
        src/widgets/scorebar.cpp \
        src/widgets/fixitemwindow.cpp \
        src/widgets/scoreprogressbar.cpp \
        src/widgets/securitylevelitem.cpp \
        src/csingleteon.cpp \
        settings_translation.cpp \
        src/widgets/basiclistdelegate.cpp \
        src/widgets/dccslider.cpp \
        src/widgets/dccsliderannotated.cpp \
        src/widgets/titledslideritem.cpp \
        src/widgets/settingsitem.cpp \
        src/widgets/basiclistmodel.cpp \
        src/widgets/settingsgroup.cpp \
        src/widgets/settingsheaderitem.cpp \
        src/widgets/translucentframe.cpp \
        src/widgets/titlelabel.cpp \
        src/widgets/titlebuttonitem.cpp \
        src/defenderdbusservice.cpp \
        src/widgets/switchwidget.cpp \
        src/widgets/defendertable.cpp

HEADERS += \
        src/window/namespace.h \
        src/window/interface/frameproxyinterface.h \
        src/window/interface/moduleinterface.h \
        src/window/mainwindow.h \
        src/window/utils.h \
        src/widgets/scorebar.h \
        src/widgets/fixitemwindow.h \
        src/widgets/scoreprogressbar.h \
        src/widgets/securitylevelitem.h \
        src/csingleteon.h \
        src/widgets/basiclistdelegate.h \
        src/widgets/dccslider.h \
        src/widgets/dccsliderannotated.h \
        src/widgets/titledslideritem.h \
        src/widgets/settingsitem.h \
        src/widgets/basiclistmodel.h \
        src/widgets/labels/normallabel.h \
        src/widgets/settingsgroup.h \
        src/widgets/settingsheaderitem.h \
        src/widgets/translucentframe.h \
        src/widgets/titlelabel.h \
        src/widgets/titlebuttonitem.h \
        src/widgets/labels/tipslabel.h \
        src/widgets/labels/smalllabel.h \
        src/widgets/labels/largelabel.h \
        src/defenderdbusservice.h \
        src/widgets/switchwidget.h \
        src/widgets/defendertable.h


isEmpty(PREFIX){
    PREFIX = /usr
}

# 删除所有的生成的qm文件
system(rm $$PWD/translations/*.qm)
CONFIG(release, debug|release) {
    message("current dir:" + $$PWD)
    TRANSLATIONS = $$files($$PWD/translations/*.ts)
    #遍历目录中的ts文件，调用lrelease将其生成为qm文件
    for(tsfile, TRANSLATIONS) {
       qmfile = $$replace(tsfile, .ts$, .qm)
       system(lrelease $$tsfile -qm $$qmfile) | error("Failed to lrelease")
    }
    #将qm文件添加到安装包
    dtk_translations.path = /usr/share/$$TARGET/translations
    dtk_translations.files = $$PWD/translations/*.qm
    INSTALLS += dtk_translations
}

dbus.files = com.deepin.defender.hmiscreen.xml

DBUS_ADAPTORS += dbus
DBUS_INTERFACES += dbus

target.path = $${PREFIX}/bin/

install_gsettings.files = ./schemas/*.gschema.xml
install_gsettings.path = $${PREFIX}/share/glib-2.0/schemas/

install_desktop.files = ./deepin-defender.desktop
install_desktop.path = $${PREFIX}/share/applications

install_qm.files = ./translations/*.qm
install_qm.path = $${PREFIX}/share/deepin-defender/translations

install_service.files = ./com.deepin.defender.hmiscreen.service
install_service.path = $${PREFIX}/share/dbus-1/services

install_docs.files = ./docs/*
install_docs.path = $${PREFIX}/share/dman/deepin-denfender

icon.path = /usr/share/icons/hicolor/scalable/apps
icon.files = $$PWD/src/window/icons/icons/deepin-defender.svg

polkit.path = /usr/share/polkit-1/actions
polkit.files = $$PWD/com.deepin.deepin-defender.policy

# 安装文件到某个路径
INSTALLS += target install_gsettings install_desktop install_autostart install_qm install_service install_docs icon polkit

deepin_professional {
# 安装 右键病毒查杀的 natiavrus.desktop
install_right.files = ./nativirus.desktop
install_right.path = $${PREFIX}/share/deepin/dde-file-manager/oem-menuextensions
# 安装文件到某个路径
INSTALLS += install_right
}

RESOURCES += \
    src/window/icons/defender_icons.qrc \
    src/window/modules/networkprotection/imageresource.qrc \
    defender.qrc

#设置配置文件
system($$DTK_SETTINGS -o settings_translation.cpp $$PWD/dt-settings.json $$PWD/dt-settings-community.json)

#管理usb设备库
unix:!macx: LIBS += \
    -L$$PWD/../../../../lib/ -ludev \
    -L$$PWD/../../../../lib/ -lrt
