#include "defenderdbusservice.h"
#include "window/mainwindow.h"

const QString service = "com.deepin.defender.hmiscreen";
const QString path = "/com/deepin/defender/hmiscreen";

DefenderDBusService::DefenderDBusService(QObject *parent)
    : QObject(parent)
{
    m_adaptor = new HmiscreenAdaptor(this);

    if (!QDBusConnection::sessionBus().registerService(service) ||
            !QDBusConnection::sessionBus().registerObject(path, this)) {
        qDebug() << "dbus service already registered! " << service;

        exit(0);
    }
}

void DefenderDBusService::Show()
{
    qDebug() << Q_FUNC_INFO;

    parent()->raise();
    if (parent()->isMinimized() || !parent()->isVisible())
        parent()->showNormal();

    parent()->activateWindow();
}

MainWindow *DefenderDBusService::parent()
{
    return qobject_cast<MainWindow *>(QObject::parent());
}

void DefenderDBusService::ShowModule(const QString &module)
{
    qDebug() << Q_FUNC_INFO << module;
    ShowPage(module, "");
    Show();
}

void DefenderDBusService::ShowPage(const QString &module, const QString &page)
{
    qDebug() << Q_FUNC_INFO << module << page << parent()->getModuleCount();

    if (parent()->getModuleCount() == 0)
        parent()->initAllModule();
    parent()->showModulePage(module, page);
}

void DefenderDBusService::ExitApp()
{
    qDebug() << Q_FUNC_INFO;
    exit(0);
}

// 显示设置弹窗
void DefenderDBusService::showSettingDialog(const QString &sGroupKey)
{
    parent()->showSettingDialog(sGroupKey);
}

void DefenderDBusService::showScanByPath(const QString sPath)
{
    // 扫描类型默认是自定义
    parent()->showRightScan(sPath);
}

// 联网管控弹框
void DefenderDBusService::showFuncConnectNetControl(QString sPkgName)
{
    parent()->showFuncConnectNetControl(sPkgName);
}

// 远程访问弹框
void DefenderDBusService::showFuncConnectRemControl(QString sPkgName)
{
    parent()->showFuncConnectRemControl(sPkgName);
}
