/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     LiLinling <lilinling_cm@deepin.com>
 *
 * Maintainer: LiLinling <lilinling_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "window/mainwindow.h"
#include "defenderdbusservice.h"

#include <DApplication>
#include <DWidgetUtil>
#include <DApplicationSettings>
#include <DLog>
#include <QObject>

#include <QDBusConnection>
#include <QDBusInterface>

DEF_USING_NAMESPACE
DWIDGET_USE_NAMESPACE
DCORE_USE_NAMESPACE

int main(int argc, char *argv[])
{
    DApplication::loadDXcbPlugin();
    DApplication a(argc, argv);
    a.setAttribute(Qt::AA_UseHighDpiPixmaps);   // 高清图
    a.setOrganizationName("deepin");
    a.setApplicationName("deepin-defender");
    a.setApplicationVersion(DApplication::buildVersion((QMAKE_VERSION)));   //pro 文件中的版本
    a.loadTranslator();
    a.setApplicationDisplayName(QObject::tr("Security Center"));
    a.setStyle("chameleon");
    a.setWindowIcon(QIcon::fromTheme("deepin-defender"));
    a.setProductIcon(QIcon::fromTheme("deepin-defender"));

    // 社区版翻译修改
    if (DSysInfo::uosEditionType() == DSysInfo::UosEdition::UosCommunity) {
        a.setApplicationDescription(QApplication::translate("main", "Security Center is a utility for system health check, firewall protection, system and application security."));
    }
    else {
        a.setApplicationDescription(QApplication::translate("main", "Security Center is a utility for virus scan, firewall protection, system and application security."));
    }

    a.setQuitOnLastWindowClosed(false);

    DApplicationSettings settings;

    DLogManager::registerConsoleAppender();
    DLogManager::registerFileAppender();

    MainWindow w;
    Dtk::Widget::moveToCenter(&w);

    //regist dbus service
    DefenderDBusService dbus(&w);

    w.show();
    return a.exec();
}
