/*
 * Copyright (C) 2019 ~ 2020 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <DFrame>
#include <DTableView>

#include <QVBoxLayout>
#include <QStandardItemModel>
#include <QHeaderView>
#include <QTableView>
#include <QScrollBar>

DWIDGET_USE_NAMESPACE

namespace def {
namespace widgets {

class DefenderTable : public DFrame
{
    Q_OBJECT
public:
    explicit DefenderTable(QWidget *parent = nullptr);
    ~DefenderTable();

    void initUI();
    void setTableAndModel(DTableView *table, QStandardItemModel *model);
    void setRowHeight(int height);

protected:
    void resizeEvent(QResizeEvent *event);
    void paintEvent(QPaintEvent *event);

private:

Q_SIGNALS:

public Q_SLOTS:

private:
    DFrame *m_mainBackgroundWidgt;
    QStandardItemModel *m_tableModel;
    DTableView *m_table;
    QList<DFrame *> m_backgroundLst;
    int m_rowHeight;
    int m_rowCount;


};

}
}
