/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "window/namespace.h"
#include "dtkwidget_global.h"

#include <QWidget>
#include <QTimer>

DEF_NAMESPACE_BEGIN
DEF_ANTIVIRUS_NAMESPACE_BEGIN

class ScoreProgressBar : public QWidget
{
    Q_OBJECT
public:
    ScoreProgressBar(QWidget *parent = 0);
    ~ScoreProgressBar();

    QSize minimumSizeHint() const;
    void setCurrentValue(int value);
    void setValue(int value);
    inline void setColor(QColor color) {m_color = color;}

protected:
    void paintEvent(QPaintEvent *);
    void resizeEvent(QResizeEvent *event);

public Q_SLOTS:
    void updateValue();

private:
    int m_currentValue;
    int m_value;
    int m_moveDir;
    QColor m_color;
    QTimer *m_timer;
};
DEF_ANTIVIRUS_NAMESPACE_END
DEF_NAMESPACE_END
