#ifndef NATIAVISOLATIONDILOG_H
#define NATIAVISOLATIONDILOG_H

#include "cominfo.h"
#include "../src/widgets/defendertable.h"

#include <QVector>
#include <QWidget>
#include <DDialog>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QLabel>
#include <QTableView>
#include <QCheckBox>
#include <QPushButton>
#include <DTableView>
#include <QStandardItem>
#include <QStandardItemModel>
#include <QStackedWidget>

#include <DCheckBox>
#include <DFrame>
#include <DSpinner>
#include <DLabel>
#include <QTimer>

QT_BEGIN_NAMESPACE
class QVBoxLayout;
class QHBoxLayout;
class QLabel;
class QPushButton;
QT_END_NAMESPACE
DWIDGET_USE_NAMESPACE
using namespace def::widgets;

/*
@classname:(NatiavIsolationDilog)
@author：(mxz)
@discptions:(病毒查杀  隔离区弹框)
@datatime:(04-30)
*/
class NatiavIsolationDilog : public DFrame
{
    Q_OBJECT
public:
    explicit NatiavIsolationDilog(QWidget *parent = nullptr);
    ~NatiavIsolationDilog();

    //界面初始化
    void initGUI();
    //初始化中间tableview布局
    QHBoxLayout *initTableWidget();

    // 当前行选中
    void currentRowClicked(QModelIndex index);

    // 判断全选按钮状态
    void checkBoxAllStatus();

    void appendFileInfo(TrustFileInfo info);

    // 设置当前进度
    void setCurrentProcess(int nCurrent);
protected:
    void resizeEvent(QResizeEvent *event);
    void closeEvent(QCloseEvent *event);

    //更改 table因改变表头宽度
    void updateTableForWidth(int nLogicalIndex, int nOldSize, int nNewSize);
    bool eventFilter(QObject *obj, QEvent *event);
    // 刷新table 因字体改变
    void refreshTableByFontChange();

signals:
    //移除隔离文件
    void requestRemoveIsolationFile(QString sPath);
public slots:
    //全选选中
    void checkAll(int nStatus);
    //移除信任
    void delteIsolation();
    //table表的单选
    void tableCheckItem();
    //接受到的隔离文件
    void receptionIsolationFile(QList<TrustFileInfo> sInfos);

    //
    void doAddBuffer();
private:
    DCheckBox            *m_checkBoxAll = nullptr;        //全选框
    QStandardItemModel   *m_model = nullptr;
    DPushButton          *m_pBIsolation = nullptr;        //移除隔离按钮
    DTableView           *m_tableView = nullptr;
    QList<TrustFileInfo>  m_isolationList ;

    QTimer                *m_buffTimer = nullptr ;        // 缓冲定时器
    QLabel                *m_proLable = nullptr;
    int                    m_total = 0;                       // 总数
    int                    m_curret = 0;                      // 当前

};

#endif // NATIAVISOLATIONDILOG_H
