#ifndef NATIAVMODULE_H
#define NATIAVMODULE_H

#include <QObject>
#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"
#include "antiviruswork.h"

#include "natiavparentwidget.h"


DEF_NAMESPACE_BEGIN
class FrameProxyInterface;
class ModuleInterface;
DEF_ANTIVIRUS_NAMESPACE_BEGIN

/*
@classname:(VirusCanModule)
@author：(mxz)
@discptions:(病毒查杀模块)
@hirts:(QObject  ModuleInterface)
@datatime:(04-28)
*/
class NatiavModule : public QObject, public ModuleInterface
{
    Q_OBJECT
public:
    explicit NatiavModule(FrameProxyInterface *frame, QObject *parent = nullptr);
    ~NatiavModule() override {}

public:
    void initialize() override;   //初始化相应模块
    void preInitialize() override;  //初始化前资源初始化
    const QString name() const override;  //模块名词
    void active(int index) override;  //模块第一次被点击进入时
    void deactive() override;        //销毁模块时

    // 获取病毒查杀work
    inline AntiVirusWork *work() { return m_work;}
    void deleteScanWidget();
    bool isbInScanningPage();
    AntiVirusWork::ScanningStatus scanningStatus();
    void scanThreatsFiles();
    void scanVirusByPath(QString sPath);

    // 返回按钮或者退出时候异常处理
    void backOrQuitThreatsOPeration();
signals:

public slots:
    // 打开病毒库更新弹窗
    void openVdbUpdateDialog();

private:
    AntiVirusWork *m_work;
    NatiavParentWidget *m_antiVirusPwidget;
    NatiavWidget *m_antiVirusHomeWidget;
    ScanWidget *m_scanWidget;
};

#endif // NATIAVMODULE_H
