#ifndef NATIAVPARENTWIDGET_H
#define NATIAVPARENTWIDGET_H

#include "natiavwidget.h"
#include "scanwidget.h"
#include "antiviruswork.h"
#include "threatsoperationthread.h"

#include <QWidget>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QDebug>
#include <DFrame>
#include <QStackedWidget>
#include <QThread>


QT_BEGIN_NAMESPACE
class QVBoxLayout;
class QHBoxLayout;
class QLabel;
class QPushButton;
QT_END_NAMESPACE
DWIDGET_USE_NAMESPACE

/*
@classname:(NatiavParentWidget)
@author：(mxz)
@discptions:(适度查杀的父页面，采用stack 展现主页和扫描页面)
@hirts:(继承)
@datatime:(05-23)
*/
class NatiavParentWidget : public QWidget
{
    Q_OBJECT
public:
    explicit NatiavParentWidget(AntiVirusWork *work, QWidget *parent = nullptr);
    ~NatiavParentWidget();
    // 扫描指定路径下的病毒
    void scanVirusByPath(QString sPath);

    // 获得病毒查杀当前页面
    int getCurrentPage();

    // 是否有没有处理的风险异常
    bool isThreats();

    void threatOperation();

    // 查杀为处理的异常文件
    void scanThreatsFiles();

    void setWork(AntiVirusWork *work);

    void setCurrentPage(int npage);

    // 获取病毒首页
    inline NatiavWidget *antiVirusHomeWidget() {return m_natiav;}
    // 获取扫描页面
    inline ScanWidget *scanWidget() {return m_scan;}
    // 删除扫描页
    void deleteScanWidget();
private:
    //初始化界面
    void initGUI();
    // 创建扫描页
    void initScanWidget();

signals:
    // 请求打开病毒查杀首页
    void notifyOpenAntiVirusHomePage();
    // 请求打开扫描页
    void notifyOpenScanVirusPage();
    // 获得病毒库版本
    void requestGetVdbVersion();

    // 右键扫描
    void onRightScan(QString sPath);

    // 更新扫描时间
    void onUpdateScanTime();

    void notifyGetThreatsFile();
    void notifyAddThreatsFile(QString path);
    void notifyDelteThreatsFile(QString path);

    // 批量处理文件
    void senBatchOperation(QList<QString> list, int nType);

public slots:


private:
    QStackedWidget          *m_stackWidget = nullptr;
    ScanWidget              *m_scan = nullptr;                    // 扫描页面
    NatiavWidget            *m_natiav = nullptr;                  //主页面
    bool                    m_isbUsbDissection;                   // 是否是usb储存设备查杀
    AntiVirusWork           *m_antivirusWork = nullptr;
    QThread                 *thread = nullptr ;
    ThreatsOPerationThread  *m_threatOperation = nullptr;        // 异常处理线程
    bool                    m_isbInScanningPage;                 // 是否处于扫描页
};

#endif // NATIAVPARENTWIDGET_H
