#ifndef NATIAVSCANLOG_H
#define NATIAVSCANLOG_H

#include "cominfo.h"
#include "../src/widgets/defendertable.h"
#include "src/window/modules/common/common.h"

#include <QWidget>
#include <DDialog>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QLabel>
#include <QTableView>
#include <QCheckBox>
#include <QPushButton>

#include <DTableView>
#include <QStandardItem>
#include <QStandardItemModel>
#include <DCheckBox>
#include <DFrame>
#include <DLabel>
#include <QEvent>
#include <DGuiApplicationHelper>
#include <QTimer>
#include <DSpinner>
#include <QStackedWidget>

QT_BEGIN_NAMESPACE
class QVBoxLayout;
class QHBoxLayout;
class QLabel;
class QPushButton;

QT_END_NAMESPACE
DWIDGET_USE_NAMESPACE
using namespace def::widgets;

/*
@classname:(NatiavScanLog)
@author：(mxz)
@discptions:(病毒查杀日志弹窗)
@hirts:(继承)
@datatime:(04-29)
*/
class NatiavScanLog : public DFrame
{
    Q_OBJECT
public:
    explicit NatiavScanLog(QWidget *parent = nullptr);

    // 界面初始化
    void initGUI();

    // 初始化中间tableview布局
    QHBoxLayout *initTableWidget();

    // 获得扫描log数据
    void getlogData();

    // 打开日志文件
    void openLogFile(QString sFilepath);

    // 删除日志文件
    void deletelogFile(QString sFilepath);

    // 当前行选中
    void currentRowClicked(QModelIndex index);

    // 判断全选按钮状态
    void checkBoxAllStatus();

    void appendFileInfo(ScanLogInfo info );

    // 设置当前进度
    void setCurrentProcess(int nCurrent);

    // 校验文本格式
    bool checkContext(QStringList list);
signals:

protected:
     bool eventFilter(QObject *obj, QEvent *event);
     // 更改table 因改变表头宽度
     void updateTableForWidth(int nLogicalIndex, int nOldSize, int nNewSize);

     // 刷新table 因字体改变
     void refreshTableByFontChange();

public slots:
    // 全选
    void checkAll(int status);

    // 删除日志
    void deleteLog();

    // table表的单选
    void tableCheckItem();

    // 主题类型改变
    void themeTypeChange(ColorType themeType);

    // 添加缓存数据
    void doAddBufferLog();
private:
    DCheckBox                    *m_checkBoxAll = nullptr;       // 全选框
    DPushButton                  *m_pBLog = nullptr;             // 删除日志
    QStandardItemModel           *m_model = nullptr;
    QTableView                   *m_tableView = nullptr;

    QString                      m_ScanLogPath;
    QString                      m_currentDir;                   // 当前文件爱你
    QStringList                  m_logFile;                      // 日志文件

    QVector<ScanLogInfo>         m_scanloglist;                  // log日志列表
    DGuiApplicationHelper        *m_guiHelper = nullptr;         // 方便得到系统主题

    QTimer                       *m_buffTimer = nullptr ;        // 缓冲定时器
    QLabel                       *m_proLable = nullptr;
    int                          m_total = 0;                       // 总数
    int                          m_curret = 0;                      // 当前

};

#endif // NATIAVSCANLOG_H
