#ifndef NATIAVTRUSTDIALOG_H
#define NATIAVTRUSTDIALOG_H

#include "cominfo.h"
#include "../src/widgets/defendertable.h"

#include <QVector>
#include <QWidget>
#include <DDialog>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QLabel>
#include <QTableView>
#include <QCheckBox>
#include <QPushButton>
#include <QStandardItem>
#include <QStandardItemModel>
#include <QStackedWidget>

#include <DCheckBox>
#include <DFrame>
#include <DTableView>
#include <DSpinner>
#include <DLabel>
#include <QTimer>

using namespace def::widgets;

QT_BEGIN_NAMESPACE
class QVBoxLayout;
class QHBoxLayout;
class QLabel;
class QPushButton;
QT_END_NAMESPACE
DWIDGET_USE_NAMESPACE

/*
@classname:(NatiavTrustDialog)
@author：(mxz)
@discptions:(病毒查杀  信任区弹框)
@datatime:(04-30)
*/
class NatiavTrustDialog : public DFrame
{
    Q_OBJECT
public:
    explicit NatiavTrustDialog(QWidget *parent = nullptr);
    ~NatiavTrustDialog();

    // 界面初始化
    void initGUI();

    // 初始化中间tableview布局
    QHBoxLayout *initTableWidget();

    // 当前行选中
    void currentRowClicked(QModelIndex index);

    // 判断全选按钮状态
    void checkBoxAllStatus();

    void appendFileInfo(TrustFileInfo info);

    // 设置当前进度
    void setCurrentProcess(int nCurrent);
protected:
    void resizeEvent(QResizeEvent *event);
    // 更改table 因改变表头宽度
    void updateTableForWidth(int nLogicalIndex, int nOldSize, int nNewSize);
    bool eventFilter(QObject *obj, QEvent *event);
    // 刷新table 因字体改变
    void refreshTableByFontChange();

    void closeEvent(QCloseEvent *event);
signals:
    // 移除隔离文件
    void requsetRemoveTrustFile(QString sPath);

public slots:
    // 全选
    void checkAll(int status);

    // 移除信任
    void deleteTrust();

    // table表的单选
    void tableCheckItem();

    // 接受信任文件
    void receptionTrustFile(QList<TrustFileInfo> sInfos);

    // 定时添加缓存
    void doAddBuffer();
private:
    DCheckBox               *m_checkBoxAll = nullptr;           // 全选框
    QStandardItemModel      *m_model = nullptr;
    DPushButton             *m_PbTrust = nullptr;               // 移除信任
    DTableView              *m_tableView = nullptr;
    QList<TrustFileInfo>    m_TrustfileInfo;

    QTimer                  *m_buffTimer = nullptr ;           // 缓冲定时器
    QLabel                  *m_proLable = nullptr;
    int                     m_total = 0;                       // 总数
    int                     m_curret = 0;                      // 当前
};

#endif // NATIAVTRUSTDIALOG_H
