#ifndef THREATSOPERATIONTHREAD_H
#define THREATSOPERATIONTHREAD_H

#include <QObject>
#include "com_deepin_defender_datainterface.h"
#include "cominfo.h"

//dbus接口 服务名称
using DataInterFaceServer = com::deepin::defender::datainterface;

// 对异常数据，以及异常数据库的操作
class ThreatsOPerationThread : public QObject
{
    Q_OBJECT
public:
    explicit ThreatsOPerationThread(QObject *parent = nullptr);

    //**************** 异常数据表的操作 ************************
    // 获得异常文件的列表
    void getThreatFileList();
    // 添加异常文件
    void addThreatsFile(QString path);
    //　删除已经操作的异常文件
    void deleteThreatsFile(QString path);

    //*************** 病毒结果页面 批量操作***************************
    // 批量处理文件
    void batchOPeration(QList<QString> list, int nType);

signals:
    // 发送异常文件列表
    void sendThreatsFileList(QString sPathList);

    // 立即修复所有问题文件
    void onAllRepairProblemFile(QString sPath);
    // 全部添加隔离
    void onAllIsolationFile(bool isbFlag, QString sPath);
    // 全部添加信任
    void onAllTruestFile(bool bFlag, QString sPath);

public slots:
    void timeOperationThreats();

private:
    DataInterFaceServer     *m_DataInterFaceServer = nullptr;     // 联网管控接口

    QList<QString>          m_list;
    Itemtype                m_type;
};

#endif // THREATSOPERATIONTHREAD_H
