/*
 * Copyright (C) 2019 ~ 2020 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "src/window/namespace.h"
#include "src/window/modules/cleaner/widgets/treewidget.h"
#include "cleanerwork.h"

#include <QWidget>
#include <QVBoxLayout>
#include <QFileInfo>
#include <QDir>
#include <QTreeView>
#include <QStandardItemModel>

DEF_NAMESPACE_BEGIN

/*
USB链接页面
*/
class CleanerWidget : public QWidget
{
    Q_OBJECT
public:
    enum Categories {
        PACKAGE_CACHE,
        CRASH_REPORTS,
        APPLICATION_LOGS,
        APPLICATION_CACHES,
        BASHSHELL_HISTORY,
        TRASH
    };

    explicit CleanerWidget(QWidget *parent = nullptr);
    ~CleanerWidget();

protected:

private:
    QHBoxLayout *initCleanerHead();
    QHBoxLayout *initSupportTypeWidget();
    QVBoxLayout *initScanResult();
    void scan();
    void addRoot(const CleanerWidget::Categories categories, const QString title,
                                const QFileInfoList infoList, bool noChild = false);
    void addChild(const QString data, const QString text,
                  const quint64 size, QTreeWidgetItem *parent);

    void handleItemClicked(QTreeWidgetItem *item, const int column);
    void prepareMenu(const QPoint &pos);
    void clean();
    void cleanAppLogs();

Q_SIGNALS:
    void sendScanFinished();

public Q_SLOTS:

private:

};

DEF_NAMESPACE_END
