#include "treeitemdelegate.h"

#include <QPainter>

TreeItemDelegate::TreeItemDelegate(QObject *parent)
    : QStyledItemDelegate(parent)
{

}

void TreeItemDelegate::paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
//    QStyledItemDelegate::paint(painter, option, index);
    if (0 == index.column()) {
        // 绘制选中按钮
        QRect rect = option.rect;
        int pix_x = rect.x() + 4;
        int pix_y = rect.y() + 4;
        int height = rect.height() - 4 * 2;
        bool isbSelected = index.model()->index(index.row(), 5).data(Qt::ItemDataRole::EditRole).toBool();
        QString sThemeIconPath = "dcc_control_button_disable";
        if (isbSelected) {
            sThemeIconPath = "dcc_control_button";
        }
        painter->drawPixmap(pix_x, pix_y, height, height,
                            QIcon::fromTheme(sThemeIconPath).pixmap(height, height));

        // 绘画文字
        int x = rect.x()+ height + 4 * 2;
        int y = rect.y();
        QString sName = index.model()->data(index.model()->index(index.row(), 0), Qt::ItemDataRole::EditRole).toString();
        painter->drawText(x, y, sName);
    }

    if (1 == index.column()) {
        // 绘画文字
        QRect rect = option.rect;
        int x = rect.x();
        int y = rect.y();
        QString sName = index.model()->index(index.row(), 1).data(Qt::ItemDataRole::EditRole).toString();
        painter->drawText(x, y, sName);
    }
}

QSize TreeItemDelegate::sizeHint(const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    return QSize(-1, 40);
}
