/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     luokai <luokai_cm@deepin.com>
 *
 * Maintainer: luokai <luokai_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include <QMap>
#include <QIcon>

#define MB 1<<10
#define GB 1<<20
#define TB 1<<30
#define KB_SECTION(temp) ((temp >= 0 && temp < (MB)) ? true : false)
#define MB_SECTION(temp) ((temp >= (MB) && temp < (GB)) ? true : false)
#define GB_SECTION(temp) ((temp >= (GB) && temp < (TB)) ? true : false)
#define TB_SECTION(temp) ((temp >= (TB)) ? true : false)
//解决转换解析的desktop与系统desktop不匹配问题

//系统更新标志
enum UpdatesStatus {
    UpdateDefault = 0,
    Checking,
    DeependenciesBrokenError,
    CheckUpdatesFailed
};

// 主题类型
enum ColorType {
    UnknownType,
    LightType,
    DarkType
};

const QSize Q_IconSize(28, 28);

// caitao/2020.6.19 define global properties
// mainwindow modules' index
#define MODULE_HOMEPAGE_INDEX              0            // 主页下标
#define MODULE_NATIAV_INDEX                1            // 病毒查杀下标
#define MODULE_NETWORK_PROTECT_INDEX       2            // 网络防护下标
#define MODULE_STARTUP_INDEX               3            // 自启动下标
#define MODULE_SYSTEM_SAFETY_INDEX         4            // 系统安全下标

// system safety modules' index
#define LOGIN_SECURITY_INDEX               0            // login security index
#define SCREEN_SECURITY_INDEX              1            // screen security index
#define UPDATE_POLICY_INDEX                2            // updating policy index
#define USB_CONNECTION_INDEX               3            // usb connection index

//字符换行
QString wordwrapText(const QFontMetrics& font, const QString& text, int nLabelSize);

// 根据流量数据大小改变单位
QString changeFlowValueUnit(double input, int prec);
// 根据网速大小改变单位
QString changeFlowSpeedValueUnit(double input, int prec);

// 改变文件大小单位，以byte为基准
QString formatBytes(double input, int prec);
