#include "detectallitem.h"
#include <pwd.h>
#include <unistd.h>

DetectAllItem::DetectAllItem(HomePageModel *model, HomePageWork *work, QObject *parent)
    : QObject(parent)
    , m_model(model)
    , m_work(work)
{

}

// 修复所有
void DetectAllItem::fixAll(QList<int> fixItemIdLst)
{
    QList<int> removelist;
    for (auto index : fixItemIdLst) {
        qDebug() << "fixAll" << index;

        switch (index) {
        case 1: {
            if (m_work->GetNetControlServer()->getNetControlDefaultStatus() == 3 || m_work->GetNetControlServer()->getNetControlDefaultStatus() == 5) {
                Q_EMIT showRepairLable("1");
                removelist << 1;
                thread()->msleep(500);
            }
            break;
        }
        case 2: {
            if (m_work->GetNetControlServer()->getRemControlDefaultStatus() == 3 || m_work->GetNetControlServer()->getRemControlDefaultStatus() == 5) {
                Q_EMIT showRepairLable("2");
                removelist << 2;
                thread()->msleep(500);
            }
            break;
        }
        case 3: {
            int sEnableInfo = 0;
            if (m_work->GetStartup()->startLauncherManage()) {  // 启动开机自启动数据管理
                QString EnableInfo = m_work->GetStartup()->getAppsInfoEnable(); // 得到所有开启状态的APP数据信息
                sEnableInfo = EnableInfo.split("|").count();
            }
            if (sEnableInfo <= 5) {
                Q_EMIT showRepairLable("3");
                removelist << 3;
                thread()->msleep(500);
            }
            break;
        }
        case 4: {
            int safetyLev = m_work->GetDaemonService()->safetygrade(); //高-0，中-1，低-2
            if (safetyLev != 2) {
                Q_EMIT showRepairLable("4");
                removelist << 4;
                thread()->msleep(500);
            }
            break;
        }
        case 5: {
            struct passwd *pws;
            pws = getpwuid(getuid());
            QString m_currentUserName = QString(pws->pw_name);
            QString user = m_work->GetAccounts()->FindUserByName(m_currentUserName);//获取当前用户名称
            m_usermanage = new DbususerManager(user);
            int date =  m_usermanage->passwordLastChange();//获取上次设置密码距1970年1月1日的天数
            const QDateTime datetime(QDateTime::currentDateTime());
            QDateTime dt = QDateTime(QDate(1970, 1, 1));//获取当天距1970年1月1日的天数
            int m_day = dt.daysTo(datetime) - date;
            if (m_day < 90) {
                Q_EMIT showRepairLable("5");
                removelist << 5;
                thread()->msleep(500);
            }
            break;
        }
        case 6: {
            //有电池
            if (m_work->haveBattery()) {
                if (m_work->getBatteryLockDelay() != 0 && m_work->getLinePowerLockDelay() != 0) {
                    Q_EMIT showRepairLable("6");
                    removelist << 6;
                    thread()->msleep(500);
                }
            } else {
                if (m_work->getLinePowerLockDelay() != 0) {
                    Q_EMIT showRepairLable("6");
                    removelist << 6;
                    thread()->msleep(500);
                }
            }
            break;
        }
//        case 7: {
//            if (m_work->GetDaemonService()->GetSystemUpdate() == 0) {
//                Q_EMIT showRepairLable("7");
//                removelist << 7;
//                thread()->msleep(500);
//            }
//            break;
//        }
        case 8: {
            if (m_work->getUpdateNotify()) {
                Q_EMIT showRepairLable("8");
                removelist << 8;
                thread()->msleep(500);
            }
            break;
        }
        case 9: {
            // 判断当前为处理异常是否为空 如果为空 则修复
            if (m_work->threatCountIsEmpty()) {
                Q_EMIT showRepairLable("9");
                removelist << 9;
                thread()->msleep(500);
            }
            break;
        }
        case 10: {
            // 判断病毒库是否更新成功 如果成功 则修复
            if (m_work->vdbUpdateSuccess()) {
                Q_EMIT showRepairLable("10");
                removelist << 10;
                thread()->msleep(500);
            }
            break;
        }
        case 11: {
            // 判断查杀间隔 如果小于30天 则修复
            int result = m_work->scanTimeInterval();
            if (result == 0) {
                Q_EMIT showRepairLable("11");
                removelist << 11;
                thread()->msleep(500);
            }
            break;
        }
        case 12: {
            // 判断查杀间隔 如果小于30天 则修复
            int result = m_work->scanTimeInterval();
            if (result == 0) {
                Q_EMIT showRepairLable("12");
                removelist << 12;
                thread()->msleep(500);
            }
            break;
        }
        default:
            break;
        }
    }
    Q_EMIT reqeuesRemoveList(removelist);
    thread()->quit();
}
