/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef HOMEPAGEMODULE_H
#define HOMEPAGEMODULE_H

#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"
#include "window/modules/homepage/homepagemodel.h"
#include "window/modules/homepage/homepagework.h"
#include "window/modules/homepage/homepagewidget.h"
#include "window/modules/homepage/examdetailpage.h"
#include "../systemsafety/loginsecurity/dbususermanager.h"
#include "animationshow.h"
#include "detectallitem.h"
#include "com_deepin_defender_hmiscreen.h"
#include "src/window/modules/common/common.h"


#include <DGuiApplicationHelper>

DEF_NAMESPACE_BEGIN
class FrameProxyInterface;
class ModuleInterface;
DEF_ANTIVIRUS_NAMESPACE_BEGIN

using HmiScreen = com::deepin::defender::hmiscreen;
class HomePageModule : public QObject, public ModuleInterface
{
    Q_OBJECT
public:
    explicit HomePageModule(FrameProxyInterface *frame, QObject *parent = nullptr);
    ~HomePageModule() override {}

public:
    void initialize() override;
    void preInitialize() override;
    const QString name() const override;
    void active(int index) override;
    void deactive() override;
    void fixAll(bool doneflag);
    void deletefixlist(int id);
    // 删除结果页
    void deleteExamDetailWidget();

Q_SIGNALS:
    void requestShowSafetyLevelWidgt(); //把信号推到mainwindow
    void showRepairLable(QString result);
    void reqeuesSetButton();

public Q_SLOTS:
    void showScoreDetailPage(QList<int> fixItemIdLst);
    void updateRepairResult();

    // 主题类型改变
    void themeTypeChange(ColorType themeType);
private:
    HomePageModel   *m_homePageModel;
    HomePageWork    *m_homePageWork;
    HomePageWidget  *m_homePageWidget;
    ExamDetailPage  *m_examDetailPage;
    QThread         *m_animationthread;
    QThread         *m_detectallitemthread;
    AnimationShow   *m_animationshow;
    DetectAllItem   *m_detectallitem;
    bool m_isbExamining{false};
    DbususerManager *m_usermanage;
    int flag = 0;
    QList<int> m_fixItemIdLst;

    HmiScreen       *m_hmiScreen        = nullptr;
    DGuiApplicationHelper       *m_guiHelper = nullptr;         // 方便得到系统主题
};

#endif // HOMEPAGEMODULE_H
DEF_ANTIVIRUS_NAMESPACE_END
DEF_NAMESPACE_END
