#include "tipwidget.h"
#include <DPalette>
#include <QHBoxLayout>
#include <QDebug>
#include <QLabel>

DWIDGET_USE_NAMESPACE

TipWidget::TipWidget(QWidget *parent)
    : DFrame(parent)
{
    QHBoxLayout *m_layout = new QHBoxLayout;
    setLineWidth(0);
    m_layout->setContentsMargins(10, 2, 10, 2);
    setMinimumSize(336, 48);

    m_leftIcon = new QLabel;

    m_tipTitle = new QLabel;
    m_tipTitle->setWordWrap(true);
    m_tipTitle->adjustSize();

    m_layout->addWidget(m_leftIcon, 0, Qt::AlignLeft | Qt::AlignVCenter);
    m_layout->addWidget(m_tipTitle, 0, Qt::AlignLeft | Qt::AlignVCenter);
    m_layout->addStretch(1);
    setLayout(m_layout);
    setBackgroundRole(QPalette::Window);
}

void TipWidget::setTitle(QString title)
{
    m_tipTitle->setText(title);
}

void TipWidget::setIcon(QIcon icon)
{
    m_leftIcon->setPixmap(icon.pixmap(20,20));
}

