/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"
#include "window/modules/networkprotection/netprowidget/appdatachart.h"
#include "window/modules/networkprotection/networkprotectionmodel.h"
#include "window/modules/networkprotection/networkprotectionworker.h"

#include <DBlurEffectWidget>
#include <DFrame>
#include <DLabel>
#include <DPushButton>
#include <DTipLabel>

#include <QWidget>
#include <QFrame>

QT_BEGIN_NAMESPACE
class QVBoxLayout;
class QHBoxLayout;
class QLabel;
class QPushButton;
QT_END_NAMESPACE

DEF_NAMESPACE_BEGIN
DEF_NETPROTECTION_NAMESPACE_BEGIN
DWIDGET_USE_NAMESPACE

class NetworkProtectionModel;
class NetworkProtectionWorker;
class AppDataDetailDialog : public DFrame
{
    Q_OBJECT
public:
    explicit AppDataDetailDialog(QString appname = "", QString pidname = "", QString icon = "", NetworkProtectionModel *model = nullptr,
                                 NetworkProtectionWorker *worker = nullptr, QWidget *parent = nullptr);

    //根据输入值流量/KB，返回 /GB、/MB或/KB为单位的字符串
    QString changeFlowValueUnit(double input, int prec);
Q_SIGNALS:

public Q_SLOTS:
    void selectTimeRangeStyle(QAction *action);

protected:
    void resizeEvent(QResizeEvent *event);
    void closeEvent(QCloseEvent *event);

private:
    void initUI();
    //更新此时间段应用总流量数据
    void updateThisRangeUsageNum();

private:
    NetworkProtectionModel *m_model;
    NetworkProtectionWorker *m_worker;
    DBlurEffectWidget *m_blurEffect;
    QWidget *m_mainWidgt;
    QString m_appName;
    QString m_pidName; //desktop name
    QString m_appIcon;
    DTipLabel *m_totalUsageNum;
    DTipLabel *m_downloadedUsageNum;
    DTipLabel *m_uploadedUsageNum;
    DPushButton *m_timeRangeSelect;
    AppDataChart *m_chart;
};

DEF_NAMESPACE_END
DEF_NETPROTECTION_NAMESPACE_END
