/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     luokai <luokai_cm@deepin.com>
 *
 * Maintainer: luokai <luokai_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "window/namespace.h"
#include "window/modules/networkprotection/networkprotectionmodel.h"

#include "dtkwidget_global.h"

#include <QDialog>
#include <QMap>
#include <QIcon>
#include <QItemDelegate>

QT_BEGIN_NAMESPACE
class QLabel;
class QComboBox;
class QHBoxLayout;
class QStandardItemModel;
class QTableView;
class QIcon;
QT_END_NAMESPACE

DEF_NAMESPACE_BEGIN
DEF_NETPROTECTION_NAMESPACE_BEGIN
class FlowMonitorControlItemDelegate : public QItemDelegate
{
public:
    FlowMonitorControlItemDelegate(QObject *parent = nullptr);

    void paint(QPainter *painter,
               const QStyleOptionViewItem &option,
               const QModelIndex &index) const;
};

class NetworkProtectionModel;
class NetworkProtectionWorker;
class NetworkAccessControlItem;
class TableViewModel;
class FlowMonitorControl : public QDialog
{
    Q_OBJECT
public:
    explicit FlowMonitorControl(NetworkProtectionModel *model = nullptr,
                                NetworkProtectionWorker *worker = nullptr, QWidget *parent = nullptr);
    static QIcon getAppIcon(const QString &appIcon);

Q_SIGNALS:

private Q_SLOTS:
    void onAppsAccessOptionsChanged(QList<NetworkProtectionModel::AppNetworkAccessStruct> list);
    void onAppOptChanged(int index);

private:
    QStandardItemModel *m_model;
    FlowMonitorControlItemDelegate *m_delegate;
    QTableView *m_view;
    NetworkProtectionModel *m_npModel;
    NetworkProtectionWorker *m_worker;
    QMap<QComboBox *, int> m_comboToAppName;
};

DEF_NAMESPACE_END
DEF_NETPROTECTION_NAMESPACE_END
