/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     wubowen <wubowen_cm@deepin.com>
 *
 * Maintainer: wubowen <wubowen_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "menuwidget.h"

#include <DTipLabel>

#include <QLabel>
#include <QComboBox>
#include <QHBoxLayout>
#include <QDebug>

DEF_USING_NAMESPACE
DEF_USING_ANTIVIRUS_NAMESPACE
DWIDGET_USE_NAMESPACE

MenuWidget::MenuWidget(QWidget *parent)
    : DFrame(parent)
    , m_topTitle(new QLabel)
    , m_content(new QComboBox)
    , m_layout(new QHBoxLayout)
{
    // 去掉边框
    //setFrameShape(QFrame::Shape::NoFrame);
    setLineWidth(0);
    m_layout->setContentsMargins(5, 5, 5, 7);
    setMinimumSize(370, 48);
    m_content->setMinimumSize(180, 36);
    m_layout->addWidget(m_topTitle,0,Qt::AlignLeft);
    m_layout->addWidget(m_content,0,Qt::AlignRight);

    setLayout(m_layout);
    setBackgroundRole(DPalette::ItemBackground);
}

void MenuWidget::setTitle(QString title)
{
    if (m_topTitle->text() != title) {
        m_topTitle->setText(title);
    }
}

void MenuWidget::setMenuData(QStringList list)
{
    if (list.count() <= 0)
        return;

    m_content->clear();
    m_content->addItems(list);
    connect(m_content, static_cast<void (QComboBox::*)(int)>(&QComboBox::currentIndexChanged), this, &MenuWidget::notifyClicked);
}

void MenuWidget::setMenuIndex(int index)
{
    m_content->setCurrentIndex(index);
}
