/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     wubowen <wubowen_cm@deepin.com>
 *
 * Maintainer: wubowen <wubowen_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"
#include "com_deepin_defender_datainterface.h"
#include "src/widgets/dccslider.h"
#include "src/window/modules/common/common.h"

#include "src/window/modules/netcontrol/netcontrolwidget.h"
#include "src/window/modules/remcontrol/remcontrolwidget.h"
#include "com_deepin_defender_hmiscreen.h"

#include <QWidget>
#include <DWidget>
#include <DScrollArea>
#include <QScrollArea>
#include <QHBoxLayout>
#include <DGuiApplicationHelper>
#include <DListView>

QT_BEGIN_NAMESPACE
class QVBoxLayout;
class QHBoxLayout;
class QLabel;
class QPushButton;
class QGSettings;
QT_END_NAMESPACE

DEF_NAMESPACE_BEGIN
DEF_NETPROTECTION_NAMESPACE_BEGIN


using namespace def::widgets;
//第一个版本屏蔽未完成的功能入口
#define bIs_Complete 1

const int leftSpace = 29;

enum WidgetType {
    Default = -1,
    FuncConnectNetControl,
    NetworkLog,
    ProfessionMode,
    Count
};

using HmiScreen = com::deepin::defender::hmiscreen;
using DataInterFaceServer = com::deepin::defender::datainterface;
class NetworkProtectionModel;
class NetworkProtectionWorker;
class TrafficDetailWidget;
class NetworkProtectionWidget : public QWidget
{
    Q_OBJECT
public:
    explicit NetworkProtectionWidget(NetworkProtectionModel *model = nullptr,
                                     NetworkProtectionWorker *worker = nullptr, QWidget *parent = nullptr);
    TrafficDetailWidget *gettrafficdetailwidget()
    {
        return widget;
    }

    // 联网管控弹框
    void showFuncConnectNetControl(const QString &sPkgName);
    // 远程访问弹框
    void showFuncConnectRemControl(const QString &sPkgName);

Q_SIGNALS:
    void notifyShowNetFlowMonitor();

private:
    void initUI();
    QVBoxLayout *initMenu();
    QHBoxLayout *initBottomButton();
    void displayWidget(QModelIndex index);
    void showNetworkLog();

    int swapIndexAndStatus(int);

protected:
    bool eventFilter(QObject *obj, QEvent *event);

private slots:
    void fireWallSwitchChange(bool isOnOff);

    // 主题类型改变
    void themeTypeChange(ColorType themeType);
private:
    //QHBoxLayout *m_mainLayout;
    QVBoxLayout *m_layout = nullptr;
    NetworkProtectionModel *m_model;
    NetworkProtectionWorker *m_worker;
    TrafficDetailWidget *widget;
    DataInterFaceServer  *m_DataInterFaceServer = nullptr; // 联网管控接口

    QPushButton     *m_resetBtn     = nullptr;          // 重置按钮
    QWidget         *mainWgt        = nullptr;          // 主空间
    QHBoxLayout     *mainLayout     = nullptr;          // 主布局

    HmiScreen        *m_hmiScreen        = nullptr;
    NetControlWidget *m_netControlWidget = nullptr;     // 联网管控弹框
    RemControlWidget *m_remControlWidget = nullptr;     // 联网管控弹框
    DGuiApplicationHelper       *m_guiHelper = nullptr;         // 方便得到系统主题
    DListView               *buttonView = nullptr;
    QStandardItemModel     *buttonModel = nullptr;
};

DEF_NAMESPACE_END
DEF_NETPROTECTION_NAMESPACE_END
