/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     luokai <luokai_cm@deepin.com>
 *
 * Maintainer: luokai <luokai_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"
#include "networkprotectionworker.h"
#include "com_deepin_defender_datainterface.h"
#include "com_deepin_defender_hmiscreen.h"
#include "src/widgets/defendertable.h"

#include <DButtonBox>
#include <DTipLabel>
#include <DCommandLinkButton>
#include <DBackgroundGroup>
#include <DFrame>
#include <DSpinner>

#include <QItemDelegate>
#include <QStandardItemModel>
#include <QTableView>
#include <QVBoxLayout>

DWIDGET_USE_NAMESPACE
using namespace def::widgets;

#define SpeedWidget_Debug 1

using DataInterFaceServer = com::deepin::defender::datainterface;
using HmiScreen = com::deepin::defender::hmiscreen;
class SpeedWidget;
class SpeedItemDelegate: public QItemDelegate
{
    Q_OBJECT
public:
    SpeedItemDelegate(SpeedWidget *widget, QObject *parent = nullptr);
    virtual ~ SpeedItemDelegate() {}

    void paint(QPainter *painter,
               const QStyleOptionViewItem &option,
               const QModelIndex &index) const;

private:
    SpeedWidget *m_widget;
};

class NetworkProtectionModel;
class NetworkProtectionWorker;
class SpeedWidget : public QWidget
{
    Q_OBJECT
public:
    explicit SpeedWidget(NetworkProtectionModel *model = nullptr,
                         NetworkProtectionWorker *worker = nullptr, QWidget *parent = nullptr);

public Q_SLOTS:
    // 更新表格数据
    void updateTable();

private:
    void SetSpeedAttributes();

private:
    NetworkProtectionModel *m_model;
    NetworkProtectionWorker *m_worker;
    QDBusPendingReply<LauncherItemInfoList> m_reply;
    QVBoxLayout *m_layout;
    DTipLabel *m_totalSpeedLabel;
    QTableView *m_speedtableview;
    QStandardItemModel *m_speeditemmodel;
    // 应用网速表格模块
    DefenderTable *m_speedTableWidget;
    SpeedItemDelegate *m_speeditem;
    DataInterFaceServer  *m_DataInterFaceServer; // 联网管控接口
    HmiScreen            *m_hmiScreen        = nullptr;
    //等待界面
    DSpinner *m_waitSpinner;
};
DEF_NAMESPACE_END
DEF_NETPROTECTION_NAMESPACE_END
