﻿/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     luokai <luokai_cm@deepin.com>
 *
 * Maintainer: luokai <luokai_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"
#include "speedwidget.h"
#include "flowwidget.h"

#include <DButtonBox>
#include <DTipLabel>
#include <DCommandLinkButton>
#include <DBackgroundGroup>
#include <DFrame>
#include <DPushButton>

#include <QItemDelegate>
#include <QStandardItemModel>

enum TabelType {
    AppsServices,
    Trafficranking,
};

QT_BEGIN_NAMESPACE
class QVBoxLayout;
class QHBoxLayout;
class QLabel;
class QTableView;
class QPushButton;
class QStandardItemModel;
class QStandardItem;
class QComboBox;
class QToolButton;
QT_END_NAMESPACE
DEF_NAMESPACE_BEGIN
DEF_NETPROTECTION_NAMESPACE_BEGIN
class NetworkProtectionModel;
class NetworkProtectionWorker;
class TrafficDetailWidget : public DFrame
{
    Q_OBJECT
public:
    explicit TrafficDetailWidget(NetworkProtectionModel *model = nullptr,
                                 NetworkProtectionWorker *worker = nullptr, QWidget *parent = nullptr);
    ~TrafficDetailWidget();

public Q_SLOTS:

protected:
    void resizeEvent(QResizeEvent *event);

private:
    void initUI();
    void showAppsServices();
    void showTrafficranking();
    void settype(TabelType type);

private:
    NetworkProtectionModel *m_model;
    NetworkProtectionWorker *m_worker;
    SpeedWidget *m_speedwidget;
    FlowWidget *m_flowwidget;
    QVBoxLayout *m_layout;        //最大布局
    QWidget *m_widget;
    DBackgroundGroup *m_bgGroup;
    QVBoxLayout *m_vlayout;
    Dtk::Widget::DButtonBox *m_topSwitchWidgetBtn;
    QList<Dtk::Widget::DButtonBoxButton *> m_btnlist;
    bool m_tabeltype = 0;
    QVBoxLayout *m_tablelayout;

    QTimer *m_updateTimer;
};
DEF_NAMESPACE_END
DEF_NETPROTECTION_NAMESPACE_END
