#ifndef REMCONTROLWIDGET_H
#define REMCONTROLWIDGET_H

#include "dtkwidget_global.h"
#include "com_deepin_defender_datainterface.h"
#include "window/namespace.h"
#include "../src/widgets/defendertable.h"

#include <DFrame>
#include <DWidget>
#include <DDialog>
#include <DLabel>
#include <DFontSizeManager>
#include <DTableView>
#include <QStandardItemModel>
#include <QHeaderView>
#include <QVBoxLayout>
#include <DPinyin>
#include <DStandardItem>
#include <DComboBox>
#include <DWidget>
#include <QHBoxLayout>
#include <QIcon>
#include <QItemDelegate>
#include <DFrame>
#include <DStyle>
#include <DPalette>

using DataInterFaceServer = com::deepin::defender::datainterface;

DEF_NAMESPACE_BEGIN
DEF_NETPROTECTION_NAMESPACE_BEGIN
DWIDGET_USE_NAMESPACE

using namespace def::widgets;

#define         NET_STATUS_ITEMASK                  0          //询问
#define         NET_STATUS_ItemAllow                1          //允许
#define         NET_STATUS_ItemDisallow             2          //禁止
#define         NET_STATUS_ItemDefaultAsk           3          //默认询问
#define         NET_STATUS_ItemDefaultAllow         4          //默认允许
#define         NET_STATUS_ItemDefaultDisallow      5          //默认禁止

class RemControlWidget;
class RemTableViewItemDelegate : public QItemDelegate
{
public:
    RemTableViewItemDelegate(RemControlWidget *widget, QObject *parent = nullptr);

    void paint(QPainter *painter,
               const QStyleOptionViewItem &option,
               const QModelIndex &index) const;
private:
    RemControlWidget *m_widget;
};

class RemControlWidget : public DDialog
{
    Q_OBJECT
public:
    explicit RemControlWidget(const QString &sPkgName, DWidget *parent = nullptr);
    ~ RemControlWidget();

    // 提供接口获取图片
    QPixmap getPixmap(const QString &appIcon, const QSize &size);

    // 设置表格选中行
    void setRemControlIndex(const QString &sPkgName);
private:
    // 初始化界面
    void initUi();

    // 初始化数据
    void initData();

private Q_SLOTS:
    // 接收所有APPS的详细信息
    void doRemAppsInfo(QList<DefenderProcInfo>);

    // 表格内下拉框选项改变
    void onAppOptChanged(int index);

Q_SIGNALS:
    // 弹框关闭信号
    void onDialogClose();

private:
    DTableView                  *m_tableView            = nullptr;                  // 表格
    QStandardItemModel          *m_tableModel           = nullptr;                  // 模型
    bool                         m_bIniFlag             = true;                     // 排序初始化标志
    RemTableViewItemDelegate    *m_tableDelegate        = nullptr;                  // 表格代理
    QMap<QComboBox *, QString>   m_comboToAppName;                                  // 联网管控表格下拉框容器
    QString                      m_sDefaultStatus;                                  // 联网管控默认状态
    const QString                m_sLocatPkgName;                                   // 用来定位的包名

    DataInterFaceServer         *m_DataInterFaceServer  = nullptr;                  // 流量监控dbus类
    DefenderTable               *m_flowTableWidget = nullptr;
};

DEF_NAMESPACE_END
DEF_NETPROTECTION_NAMESPACE_END

#endif // REMCONTROLWIDGET_H
