/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "safetylevelmodel.h"

#include <QGSettings>

SafetyLevelModel::SafetyLevelModel(QObject *parent)
    : QObject(parent)
    , m_gs(nullptr)
{
    //使用GSetting读取参数
    m_gs = new QGSettings(DeepinDefenderGSettings, QByteArray(), this);

}

int SafetyLevelModel::getSafetyScore()
{
    return m_gs->get(GSettingsSafetyScore).toInt();
}

int SafetyLevelModel::getSafetyLevel()
{
    return m_gs->get(GSettingsSafetyLevel).toInt();
}
