/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "window/namespace.h"
#include "dtkwidget_global.h"

#include <QGSettings>

DEF_NAMESPACE_BEGIN
DEF_ANTIVIRUS_NAMESPACE_BEGIN

//定义在homepagemodel.cpp中
extern const QByteArray DeepinDefenderGSettings;
extern const QString GSettingsSafetyScore;
extern const QString GSettingsSafetyLevel;
extern const QString GSettingsLocalVer;
extern const QString GSettingsLatestVer;
extern const QString GSettingsLastKillStyle;
extern const QString GSettingsLastKillDate;

class SafetyLevelWork;

class SafetyLevelModel : public QObject
{
    Q_OBJECT
public:
    explicit SafetyLevelModel(QObject *parent = nullptr);
    friend class SafetyLevelWork;

Q_SIGNALS:

public Q_SLOTS:

public:
public:
    int getSafetyScore(); //获取当前系统安全评分
    int getSafetyLevel();

private:
    QGSettings *m_gs;
};

DEF_ANTIVIRUS_NAMESPACE_END
DEF_NAMESPACE_END
