/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "safetylevelmodule.h"
#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"

SafetyLevelModule::SafetyLevelModule(FrameProxyInterface *frame, QObject *parent)
    : QObject(parent)
    , ModuleInterface(frame)
    , m_safetylevelModel(nullptr)
    , m_safetylevelWork(nullptr)
    , m_safetylevelWidget(nullptr)
{

}

void SafetyLevelModule::initialize()
{

}

void SafetyLevelModule::preInitialize()
{
    m_safetylevelModel = new SafetyLevelModel;
    m_safetylevelWork = new SafetyLevelWork(m_safetylevelModel);
}

const QString SafetyLevelModule::name() const
{
    return "safetylevel";
}

void SafetyLevelModule::active(int index)
{
    Q_UNUSED(index);
    m_safetylevelWidget = new SafetyLevelWidget;
    m_safetylevelWidget->setModelAndWork(m_safetylevelModel, m_safetylevelWork);

    m_frameProxy->pushWidget(this, m_safetylevelWidget);
}

void SafetyLevelModule::deactive()
{

}
