/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "window/namespace.h"
#include "dtkwidget_global.h"
#include "window/interface/frameproxyinterface.h"
#include "window/interface/moduleinterface.h"
#include "window/modules/safetylevel/safetylevelwork.h"
#include "widgets/securitylevelitem.h"

#include <DSuggestButton>

#include <QWidget>
#include <QPushButton>
#include <QRadioButton>

DWIDGET_BEGIN_NAMESPACE
class DSuggestButton;
DWIDGET_END_NAMESPACE

QT_BEGIN_NAMESPACE
class QHBoxLayout;
class QLabel;
class QPushButton;
QT_END_NAMESPACE

DEF_NAMESPACE_BEGIN
DEF_ANTIVIRUS_NAMESPACE_BEGIN

DWIDGET_USE_NAMESPACE

class SafetyLevelWidget : public QWidget
{
    Q_OBJECT
public:
    enum SafetyLevel{null, high, middle, low};
public:
    explicit SafetyLevelWidget(QWidget *parent = nullptr);

    void setModelAndWork(SafetyLevelModel *mode, SafetyLevelWork *work);
    void updateUI();
    void safetyLevelSetting(int level);
    void showBottomTip(int level, int lastLevel);

private:

Q_SIGNALS:

public Q_SLOTS:
    void closeBottomTip();

private:
    SafetyLevelModel *m_mode;
    SafetyLevelWork *m_work;
    QButtonGroup *m_safetyLevelBtnGroup;
    SecurityLevelItem *m_highLevelItem;
    SecurityLevelItem *m_midLevelItem;
    SecurityLevelItem *m_lowLevelItem;
    QLabel *m_rightImg;
    QLabel *m_bottomTipIcon;
    QLabel *m_bottomIncreasingScore;
    QLabel *m_bottomCurrentScoreLabel;
    QLabel *m_bottomCurrentScore;
    QTimer *m_closeBottomTimer;
};

DEF_ANTIVIRUS_NAMESPACE_END
DEF_NAMESPACE_END
