/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci_cm@deepin.com>
 *
 * Maintainer: caimengci <caimengci_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "startupmodule.h"
#include "window/interface/moduleinterface.h"

#include <QModelIndex>
#include <QStandardItemModel>

StartupModule::StartupModule(FrameProxyInterface *frame, QObject *parent)
    : QObject(parent)
    , ModuleInterface(frame)
    , m_DataInterFaceServer(new DataInterFaceServer("com.deepin.defender.datainterface", "/com/deepin/defender/datainterface", QDBusConnection::sessionBus(), this))
{
}

void StartupModule::initialize()
{

}

void StartupModule::preInitialize()
{
    //m_StartupServerInter->preInitialize();
}

const QString StartupModule::name() const
{
    return "startup";
}

void StartupModule::active(int index)
{
    Q_UNUSED(index);
    m_widget = new StartupWidget(m_DataInterFaceServer);

    connect(m_DataInterFaceServer, SIGNAL(AccessRefreshData(bool, QString)), m_widget, SLOT(refreshData(bool, QString)));
    connect(m_DataInterFaceServer, SIGNAL(notifyUpdateLauncherList()), m_widget, SLOT(getAppsData()));

    m_frameProxy->pushWidget(this, m_widget);
}

void StartupModule::deactive()
{

}
