/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci_cm@deepin.com>
 *
 * Maintainer: caimengci <caimengci_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "startupwidget.h"
#include "com_deepin_defender_datainterface.h"

#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"

using DataInterFaceServer = com::deepin::defender::datainterface;

DEF_NAMESPACE_BEGIN
DEF_ANTIVIRUS_NAMESPACE_BEGIN

class ModuleInterface;
class FrameProxyInterface;
class StartupModule : public QObject, public ModuleInterface
{
    Q_OBJECT
public:
    explicit StartupModule(FrameProxyInterface *frame, QObject *parent = nullptr);
    ~StartupModule() override {}

public:
    void initialize() override;
    void preInitialize() override;
    const QString name() const override;
    void active(int index) override;
    void deactive() override;

Q_SIGNALS:
    void requestShowSafetyLevelWidgt(); // 把信号推到mainwindow

private: bool m_isbExamining{false};

private:
    StartupWidget  *m_widget = nullptr;
    DataInterFaceServer *m_DataInterFaceServer    = nullptr;      // 取应用数据接口

};
DEF_ANTIVIRUS_NAMESPACE_END
DEF_NAMESPACE_END
