/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     luokai <luokai_cm@deepin.com>
 *
 * Maintainer: luokai <luokai_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"
#include "../systemsafetymodel.h"
#include "../systemsafetywork.h"
#include "widgets/securitylevelitem.h"
#include "dbususermanager.h"
#include "com_deepin_daemon_accounts.h"
#include "com_deepin_defender_daemonservice.h"

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QStandardItemModel>
#include <QButtonGroup>
#include <QRadioButton>
#include "passwordmenu.h"
#include "tipswidget.h"
#include <QGSettings>
#include <DTipLabel>
#include "dtkwidget_global.h"
#include "src/widgets/titlebuttonitem.h"
#include "src/widgets/titledslideritem.h"
#include "src/widgets/dccslider.h"

#include <DFrame>

#define user_passwor_tip 0

using DaemonService = com::deepin::defender::daemonservice;
using accounts = com::deepin::daemon::Accounts;

DEF_NAMESPACE_BEGIN
DWIDGET_USE_NAMESPACE
using namespace def::widgets;
class LoginSecurityWidget : public QWidget
{
    Q_OBJECT
public:
    enum LoginSecurity{high = 0, middle, low};
public:
    explicit LoginSecurityWidget(SystemSafetyModel *model, SystemSafetyWork *work, QWidget *parent = nullptr);
    ~LoginSecurityWidget();
    void initui();
    void Setlastchage();
    void onButtonClicked(int button);
    void setStyle(int grade);
    QString sliderValueToLiteralString(const int delay) const;

public Q_SLOTS:
private:
    SystemSafetyModel *m_model;
    SystemSafetyWork *m_work;
    accounts *m_accounts;
    DaemonService *m_daemonservice;
    DbususerManager *m_usermanage;
    QString user;
    QVBoxLayout *m_layout;
#ifdef user_passwor_tip
    QLabel *m_PasswodUpdateTips;
#endif
    QButtonGroup *m_pButtonGroup;
    SecurityLevelItem *m_highLevelItem;
    SecurityLevelItem *m_mediumLevelItem;
    SecurityLevelItem *m_lowLevelItem;
    TitledSliderItem *m_linepasswordSliderItem;
    PassWordMenu *m_menu;
    TipsWidget *m_tip;
    qint64 m_day = 0;
};
