/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     luokai <luokai_cm@deepin.com>
 *
 * Maintainer: luokai <luokai_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "passwordmenu.h"

#include <DTipLabel>

#include <QLabel>
#include <QComboBox>
#include <QHBoxLayout>
#include <QDebug>
#include <QPushButton>

DEF_USING_NAMESPACE
DEF_USING_ANTIVIRUS_NAMESPACE
DWIDGET_USE_NAMESPACE

PassWordMenu::PassWordMenu(QWidget *parent)
    : DFrame(parent)
    , m_topTitle(new QLabel)
    , m_content(new QPushButton)
    , m_layout(new QHBoxLayout)
{
    m_layout->setContentsMargins(10, 5, 10, 7);
    m_layout->addWidget(m_topTitle);
    m_layout->addStretch(1);

    m_layout->addWidget(m_content , 0, Qt::AlignRight);

    setLayout(m_layout);
    setBackgroundRole(DPalette::ItemBackground);
    setLineWidth(0);
}

void PassWordMenu::setTitle(QString title)
{
    if (m_topTitle->text() != title) {
        m_topTitle->setText(title);
    }
}

void PassWordMenu::setMenuData(QString list)
{
    if (list.count() <= 0)
        return;

    m_content->setText(list);
    connect(m_content, &QPushButton::clicked, this, &PassWordMenu::notifyClicked);
}
