/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     luokai <luokai_cm@deepin.com>
 *
 * Maintainer: luokai <luokai_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "window/namespace.h"

#include <DFrame>

QT_BEGIN_NAMESPACE
class QLabel;
class QComboBox;
class QHBoxLayout;
class QPushButton;
QT_END_NAMESPACE

DEF_NAMESPACE_BEGIN
DEF_NETPROTECTION_NAMESPACE_BEGIN

class PassWordMenu : public DTK_WIDGET_NAMESPACE::DFrame
{
    Q_OBJECT
public:
    explicit PassWordMenu(QWidget *parent = nullptr);

    void setTitle(QString title = "");
    void setMenuData(QString list);

Q_SIGNALS:
    void notifyClicked();

private:
    QLabel *m_topTitle;
    QPushButton *m_content;
    QHBoxLayout *m_layout;
};

DEF_NAMESPACE_END
DEF_NETPROTECTION_NAMESPACE_END
