#include "tipswidget.h"
#include <DLabel>

TipsWidget::TipsWidget(SystemSafetyModel *model, SystemSafetyWork *work, QWidget *parent)
    : DDialog (parent)
    , m_model(model)
    , m_work(work)
{
//    setCloseButtonVisible(false);
    this->DDialog:: setWindowFlag(Qt::WindowStaysOnTopHint);
    this->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
    this->setModal(true);
    InitUI();
    connect(this, &DDialog::buttonClicked, this, [ = ](int index, const QString & text) {
        Q_UNUSED(text);
        Q_UNUSED(index);
        m_work->GetControlCenter()->ShowModule("accounts");
    });
}

TipsWidget::~TipsWidget()
{

}

void TipsWidget::InitUI()
{
    clearContents();//清除文本
    clearButtons();//清除按钮
    DLabel *txt = nullptr;
    txt = new DLabel(tr("Your password policy is higher, please change your password to meet the requirements"));
    txt->setWordWrap(true);//设置换行
    addContent(txt);
    addButton(tr("OK"), true, DDialog::ButtonRecommend);//设置按钮
}
