/*
 * Copyright (C) 2019 ~ 2020 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "../systemsafetymodel.h"
#include "../systemsafetywork.h"
#include "window/namespace.h"
#include "dtkwidget_global.h"
#include "src/widgets/titlebuttonitem.h"
#include "src/widgets/titledslideritem.h"
#include "src/widgets/dccslider.h"

#include <QWidget>

DEF_NAMESPACE_BEGIN
DWIDGET_USE_NAMESPACE
using namespace def::widgets;

class ScreenSecurityWidget : public QWidget
{
    Q_OBJECT
public:
    explicit ScreenSecurityWidget(SystemSafetyModel *model, SystemSafetyWork *work, QWidget *parent = nullptr);
    ~ScreenSecurityWidget();
private:
    int sliderValueToLockDelayValue(int sliderValue);
    int lockDelayValueToSliderValue(int lockValue);
    QString sliderValueToLiteralString(const int delay) const;

Q_SIGNALS:

public Q_SLOTS:
    void changeLinePowerLockDelay(int value);
    void changeBatteryLockDelay(int value);

private:
    SystemSafetyModel *m_model;
    SystemSafetyWork *m_work;
    TitledSliderItem *m_linePowerLockSliderItem;
    TitledSliderItem *m_batteryLockSliderItem;
};

DEF_NAMESPACE_END
