/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     luokai <luokai@deepin.com>
 *
 * Maintainer: luokai <luokai@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "window/namespace.h"
#include "dtkwidget_global.h"
#include "window/modules/common/common.h"

DEF_NAMESPACE_BEGIN
DEF_ANTIVIRUS_NAMESPACE_BEGIN

class SafetyLevelWork;
class SystemSafetyModel : public QObject
{
    Q_OBJECT
public:
    explicit SystemSafetyModel(QObject *parent = nullptr);
    ~SystemSafetyModel();

    void setSystemVersionInfo(QString systemVersionInfo);
    inline QString systemVersionInfo() {return m_systemVersionInfo;}
    void setUpdateStatus(const UpdatesStatus &status);
    inline UpdatesStatus updateStatus() {return m_updateStatus;}
    //设置是否自动检查更新（更新提醒）
    inline void setIsbAutoCheckUpdates(bool isbAuto) {m_isbAutoCheckUpdates = isbAuto;}
    inline bool isbAutoCheckUpdates() {return m_isbAutoCheckUpdates;}
    inline void setIsbAutoDownloadUpdates(bool isbAuto) {m_isbAutoDownloadUpdates = isbAuto;}
    inline bool isbAutoDownloadUpdates() {return m_isbAutoDownloadUpdates;}

Q_SIGNALS:
    void updateStatusChanged(const UpdatesStatus &status);
    void sendHaveUpdates(bool have);

public Q_SLOTS:

private:

private:
    UpdatesStatus m_updateStatus;
    QString m_systemVersionInfo;
    bool m_isbAutoCheckUpdates;
    bool m_isbAutoDownloadUpdates;
};

DEF_ANTIVIRUS_NAMESPACE_END
DEF_NAMESPACE_END
