/*
 * Copyright (C) 2019 ~ 2020 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <DPushButton>

#include <QVBoxLayout>
#include <QTimer>
#include <QtSvg/QSvgRenderer>

DWIDGET_USE_NAMESPACE

namespace def {
namespace widgets {

class CheckingButton : public QWidget
{
    Q_OBJECT
public:
    explicit CheckingButton(QWidget *parent = nullptr);
    ~CheckingButton();

    void initUI();
    void setRotatingSvgRender(QString svgPath);
    inline DPushButton *button() {return m_btn;}
    void startRotating();
    void pauseRotating();

protected:
    void resizeEvent(QResizeEvent *event);
    void paintEvent(QPaintEvent *event);

private:
    void rotating();

Q_SIGNALS:

public Q_SLOTS:

private:
    int m_rotateAngle;
    QTimer *m_rotatingTimer;
    DPushButton *m_btn;
    QSvgRenderer m_rotatingSvgRender;
};

}
}
