#ifndef USBMANAGEMONITOR_H
#define USBMANAGEMONITOR_H

#include "usbmonitorconfig.h"

#include <QObject>

struct UsbDeviceInfo {
    QString product;
    QString serial;
    QString idVendor;
    QString idProduct;
    QString bInterfaceClass;
};

class UsbManageMonitor : public QObject
{
    Q_OBJECT
public:
    explicit UsbManageMonitor(QObject *parent = nullptr);
    void init();
    void quit();
    void setUSBModelAndWhiteList(const QString sFlag, const QString sWhiteList);

private:
    void monitor_devices(struct udev *udev);
    void process_device(struct udev_device *dev);
    //检查设备是否在白名单中，存在则返回0
    int check_whitelist(struct udev_device *dev);
    //断开设备，成功返回0
    int disconnect_device(struct udev_device *dev);
    void updateConfig();
Q_SIGNALS:
    //usb设备接入的信号，入参bflag 为false,表示限制状态
    void checkUsbInsert(bool bFlag, QString sUsbInfo);
public slots:

private:
    //运行状态
    int m_status; //1-运行 0-停止
    //提供usb检控的相关属性设置
    UsbMonitorConfig *m_usbMonitorConfig;
    //limitation model
    QString m_sFlag;
    QString m_sWhiteList;

    int m_recCount;
    //断开设备标志 0-断开
    int m_disConnectFlag;
    UsbDeviceInfo m_usbDeviceInfo;
    QString m_usbDeviceInfoStr;

};

#endif // USBMANAGEMONITOR_H
