#ifndef COMINFO_H
#define COMINFO_H

#include <QString>

// 扫描状态
enum DissectionState {
    Pause,
    Continue,
    Stop,
};

// 扫描类型
enum SnanType {
    AllScam = 0,         // 全盘
    QuickScan,           // 快速
    CustomerScan         // 自定义
};

// 扫描单个结果操作类型
enum Itemtype {
    Repair = 0,         // 维修
    Delete,             // 删除
    isolation,          // 隔离
    Trust               // 信任
};



// 扫描单个结果操作内容
struct ItemWidgetInfo {
    QString path;               // 标题
    int status;                 // 状态信息   完成  修复  删除
    QString discriptionInfo;    // 描述信息
};

// 病毒类型
enum Type {
    Normal,             //正常,
    Trojan,             //木马
    TrojanDownloader,   //下载者木马
    TrojanSpy,          //间谍木马
    TrojanDropper,      //释放器木马
    TrojanClicker,      //点击器木马
    TrojanProxy,        //代理木马
    Backdoor,           //后门远控
    Worm,               //蠕虫
    Virus,              //感染型木马
    Ransom,             //勒索软件
    Rogue,              //流氓行为
    Rootkit,            //内核后门密码
    Bootkit,            //引导后门密码
    OMacro,             //宏病毒
    DOC,                //恶意文档
    Adware,             //恶意广告
    Constructor,        //病毒生成器
    HackTool,           //黑客工具
    VirTool,            //代码混淆器
    Exploit,            //漏洞利用
    Joke,               //玩笑程序
    Other               //其他
};

//文件信息
struct FileInfo {
    QString path;                   // 文件路径
    Type type;                      // 扫描的类型
    double dProgress ;              // 进度
    QString detail;                 // 信息
};

//查杀日志结构体
struct ScanLogInfo {
    QString datetime;                // 查杀时间
    QString scanType;                // 扫描类型
    QString result;                  // 扫描结果
    QString filePath;                // 文件路径
};

// 信任/隔离文件结构体
struct TrustFileInfo {
    QString sFilePath;               // 文件路径
    QString sFileName;               // 文件名
    QString sAddTime;                // 添加时间
};

#endif // COMINFO_H
